//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop
#include "SybaseDataBase.h"
#include <ExtCtrls.hpp>  
#include <registry.hpp>

#pragma package(smart_init)  
#pragma resource "SybLogindlg.dfm"


__int64       _RTLENTRY _EXPFUNC _atoi64(const char * __s);

char SybErr[1000];

int _stdcall   err_handler(
DBPROCESS *dbproc,
int	  severity,
int	  dberr,
int	  oserr,
char	  *dberrstr,
char	  *oserrstr);  
int _stdcall  msg_handler(
DBPROCESS *dbproc,
long	  msgno,
int	  msgstate,
int	  severity,
char	  *msgtext,
char	  *srvname,
char	  *procname,
int	  line);


AnsiString GServerName;
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//                                                 
//---------------------------------------------------------------------------

static inline void ValidCtrCheck(TSybaseDatabase *)
{
        new TSybaseDatabase(NULL);
}
//---------------------------------------------------------------------------
// Register the component and property Editors
//---------------------------------------------------------------------------
namespace Sybasedatabase
{
        void __fastcall PACKAGE Register()
        {
                RegisterPropertyEditor( __typeinfo(TString), __classid(TSybaseDatabase), "UseServerName",
                __classid(TSybObjectProperty));          
                RegisterPropertyEditor( __typeinfo(TString), __classid(TSybaseDatabase), "UseDataBase",
                __classid(TSybObjectProperty));

                 TComponentClass classes[1] = {__classid(TSybaseDatabase)};
                 RegisterComponents("SYBASE", classes, 0);
        }
}
//---------------------------------------------------------------------------
// Methods for the  property editor
//---------------------------------------------------------------------------

__fastcall TSybObjectProperty::~TSybObjectProperty()
{
//
}                                 
//---------------------------------------------------------------------------

void __fastcall TSybObjectProperty::Initialize(void)
{
 ThisComponent = GetComponent(0);  // point to this component being edited
 ptr = (TSybaseDatabase*)ThisComponent;  // 'cast' the pointer
 
}

//---------------------------------------------------------------------------

 TPropertyAttributes __fastcall TSybObjectProperty::GetAttributes()
{
TPropertyAttributes pa;
  (pa << paValueList  << paAutoUpdate << paMultiSelect)  >> paRevertable;
  return  pa;
}
//-------------------------------------------------------------------------

System::AnsiString __fastcall TSybObjectProperty::GetValue()
{
 if(GetName()=="UseDataBase") return ptr->DataBase;
 if(GetName()=="UseServerName")return ptr->ServerName;
 return "";
}
//-------------------------------------------------------------------------

void __fastcall TSybObjectProperty::GetValues(Classes::TGetStrProc Proc)
{
RETCODE RC;
char name[50]; 
int i=0;
TServerList *ServerListSource;

  if(GetName()=="UseServerName")
  try
  {
    ServerListSource = new TServerList();
    ServerListSource->CheckForSybase();
    while(i < ServerListSource->OutStringList->Count )
        Proc(ServerListSource->OutStringList->Strings[i++]);
   }
   __finally{ 
    if(ServerListSource)delete ServerListSource;
   }

   if(GetName()=="UseDataBase"){
     if(!ptr->Connected)Proc("master");
     else {
      if( dbcmd(ptr->dbproc,"select name from master..sysdatabases")==FAIL){
          MessageDlg("Could not load dbcmd to read from master..sysdatabases",\
          mtWarning , TMsgDlgButtons() << mbOK , 0);
          return;
          }
      if(dbsqlexec(ptr->dbproc)==FAIL){
          MessageDlg("Could not execute dbsqlexec to read from master..sysdatabases",\
          mtWarning , TMsgDlgButtons() << mbOK , 0);
          return;
          }
      while ((RC = dbresults(ptr->dbproc))!=NO_MORE_RESULTS) {
        if ((RC == SUCCEED)&& (DBROWS(ptr->dbproc) == SUCCEED)) {
          dbbind(ptr->dbproc, 1, STRINGBIND, (DBINT) 0, (BYTE*)name);
          while (dbnextrow(ptr->dbproc)!= NO_MORE_ROWS){
            Proc(StrPas(name));
          }
        }
     }
   }
  }
}
//---------------------------------------------------------------------------

void __fastcall TSybObjectProperty::SetValue(const System::AnsiString Value)
{
 if(GetName()=="UseServerName") ptr->ServerName = Value;
 if(GetName()=="UseDataBase"){
   ptr->DataBase = Value;
   if(ptr->Connected)
     if(dbuse(ptr->dbproc,ptr->DataBase.c_str())==FAIL)
       MessageDlg("Failed changeing to a different database",\
       mtWarning , TMsgDlgButtons() << mbOK , 0);
 }
}

//---------------------------------------------------------------------------
// Constructor / Destructor and methods of the TServerList Class
// This object has one method which simply reads the list of databases from the
// sql.ini file.  It locates the ini file by examining the windows registry.
// it won't find the file if you did not 'install' the Sybase client
//---------------------------------------------------------------------------

_fastcall TServerList::TServerList() : TStringList() //constructor
{
OutStringList = new TStringList();
}
//---------------------------------------------------------------------------

_fastcall TServerList::~TServerList()
{
delete OutStringList;
}
//---------------------------------------------------------------------------

void __fastcall TServerList::CheckForSybase()
{

TRegistry *MyReg;
AnsiString Path;
TStringList *SQLFile;
int i,j;
//bool test;

MyReg = new TRegistry;
SQLFile = new TStringList;

try                              // HKEY_LOCAL_MACHINE\SOFTWARE\SYBASE\Setup
  {
  MyReg->RootKey = HKEY_LOCAL_MACHINE;
  if (MyReg->OpenKeyReadOnly("\\SOFTWARE\\SYBASE\\Setup")==false)
    {
     MessageDlg("No Registry entry found for Sybase Open Client.",\
      mtWarning , TMsgDlgButtons() << mbOK , 0);
     return;
    }
  Path = MyReg->ReadString("SYBASE");
  MyReg->CloseKey();
  }
__finally
  {
  delete MyReg;
  }


try
  {
  SQLFile->LoadFromFile(Path+"\\INI\\Sql.ini");
  // now extract the database names
   OutStringList->Clear();

   for (i=0;i<SQLFile->Count;i++)
    {
     if (SQLFile->Strings[i].SubString(1,1)=="[")
       {
       j = SQLFile->Strings[i].AnsiPos("]");
        OutStringList->Add(SQLFile->Strings[i].SubString(2, j-2));
       }
    }
   }
__finally
  {
  delete SQLFile;
  }
}

//---------------------------------------------------------------------------
// SybLoginDLG is a small form which pops up when you call
// TSybaseDatabase->Connect().
//---------------------------------------------------------------------------

__fastcall TSybLoginDLG::TSybLoginDLG() : TForm(Owner)                       // constructor
{
try{
  ServerListSource = new TServerList();
  ServerListSource->CheckForSybase();
  ServerList->Items->Assign(ServerListSource->OutStringList);
  }
  __finally{
   if(ServerListSource)delete ServerListSource;
  }
  Pass->PasswordChar='*';
  ServerList->Sorted=true;
  ServerList->ItemIndex=0;
  Label2->Caption="Password";
}
//---------------------------------------------------------------------------

__fastcall TSybLoginDLG::~TSybLoginDLG()                       // destructor
{
//
}
//---------------------------------------------------------------------------

void __fastcall TSybLoginDLG::CancelButtClick(TObject *Sender)
{
ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

void __fastcall TSybLoginDLG::LoginButtClick(TObject *Sender)
{
ModalResult = mrOk;
}

//---------------------------------------------------------------------------

void __fastcall TSybLoginDLG::UserKeyPress(TObject *Sender, char &Key)
{
 if(Key=='\r')Pass->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TSybLoginDLG::PassKeyPress(TObject *Sender, char &Key)
{
 if(Key=='\r')ServerList->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TSybLoginDLG::ServerListKeyPress(TObject *Sender,
      char &Key)
{
 if(Key=='\r')DataBase->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TSybLoginDLG::DataBaseKeyPress(TObject *Sender, char &Key)
{
 if(Key=='\r')ModalResult = mrOk;
}
//---------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// The main component
//---------------------------------------------------------------------------

__fastcall TSybaseDatabase::TSybaseDatabase(TComponent *Owner)    // constructor
        : TComponent(Owner)
{
  dbmsghandle(msg_handler);
  dberrhandle(err_handler);
  FLoginPrompt=false;
  DataBase="master";
  FBuffersize=1000;  // default dblibrary size =1000
  FCharSet="";
  FServerCharSet="";
  FConnected=false;
  FCancelMessages=false;
  FServerName=new TString();
  FLoginTimeOut=100;
  FTimeOut=10;
  FClientCharSet="iso_1";
  FPacketSize=512;

    if (F1==0){ // F1=0 if this is the 1st DB object put on a form
      AllSybDatabases = new TList();
      F1=1;
    }
    if (AllSybDatabases->IndexOf(this) == -1) AllSybDatabases->Add(this);
        else
          AllSybDatabases->Items[AllSybDatabases->IndexOf(this)]=this;
}
//---------------------------------------------------------------------------

__fastcall TSybaseDatabase::~TSybaseDatabase()   // destructor
{
if(dbproc)try{
  dbclose(dbproc);
  dbexit();
  }
__finally{}
if(FServerName)delete FServerName;
if(AllSybDatabases->Count==1){AllSybDatabases->Clear();delete AllSybDatabases;}
}

//---------------------------------------------------------------------------

int _stdcall   err_handler(
DBPROCESS *dbproc,
int	  severity,
int	  dberr,
int	  oserr,
char	  *dberrstr,
char	  *oserrstr)
{

	if ((dbproc == NULL) )
		return(INT_CANCEL );

	if (dberrstr != NULL){
                    strcat(SybErr,"DB_Library error:  ");
		    strcat(SybErr,dberrstr);
                    strcat(SybErr,"\n");
         }
	if (oserr != DBNOERR){      // error 4002 means can't connect to server
                    strcat(SybErr,"Operating-system error:  ");
		    strcat(SybErr,oserrstr);
                    strcat(SybErr,"\n");
         }


	return(INT_CANCEL);
}
//---------------------------------------------------------------------------

int _stdcall  msg_handler(
DBPROCESS *dbproc,
long	  msgno,
int	  msgstate,
int	  severity,
char	  *msgtext,
char	  *srvname,
char	  *procname,
int	  line)
{

	if (msgno == 5701 || msgno == 5703 || msgno == 5704
                || msgno == 1805 || msgno == 0){

                return (0);
		}

                    strcat(SybErr,"SQL Server message: ");
		    strcat(SybErr,msgtext);
                    strcat(SybErr,"\n");


	return(0);
}                                                      
//---------------------------------------------------------------------------

void _fastcall TSybaseDatabase::SetAppName(AnsiString Value )
{
  FAppName=Value;
}
//----------------------------------------------------------------------------

void _fastcall TSybaseDatabase::SetConnected(bool Value)
{
 if(Value)Connect();
 else DisConnect();
}   
//----------------------------------------------------------------------------

void _fastcall TSybaseDatabase::SetUserName(AnsiString Value  )
{
  FUserName=Value;
}                                                                             
//----------------------------------------------------------------------------

void _fastcall TSybaseDatabase::SetPasswordPlus(AnsiString Value  )
{
  FPasswordPlus=Value;
}                                                                         
//----------------------------------------------------------------------------


void _fastcall TSybaseDatabase::SetBufferSize(int Value )
{
char *p;
AnsiString    s;

  FBuffersize=Value;
  s=IntToStr(Value);
  p = new char[s.Length() + 1];
  strcpy(p,(const char*)s.c_str());
  if ((Value > 0)&&(FConnected))
  {
    if(dbsetopt(dbproc,DBBUFFER,p,-1)==FAIL){
      if(!FCancelMessages)
         MessageDlg("Can't set the buffer size\r"+StrPas(SybErr), mtWarning , TMsgDlgButtons() << mbOK , 0);
      if(OnSetBufferSizeFail)OnSetBufferSizeFail(this,SybErr);
    }
  }
  delete(p);
}                     
//----------------------------------------------------------------------------

void _fastcall TSybaseDatabase::SetPassword(AnsiString Value  )
{
  FPassword=Value;
}                             
//----------------------------------------------------------------------------

void _fastcall TSybaseDatabase::SetLoginPrompt(bool Value )
{
  FLoginPrompt=Value;  
}
//----------------------------------------------------------------------------

void _fastcall TSybaseDatabase::SetCancelMessages(bool Value )
{
  FCancelMessages=Value;
}
//----------------------------------------------------------------------------

void _fastcall TSybaseDatabase::SetClientCharSet(AnsiString Value )
{
  FClientCharSet=Value;
}
//----------------------------------------------------------------------------

int _fastcall TSybaseDatabase::GetPacketSize()
{
  if(!Connected)return FPacketSize;
  else return dbgetpacket(dbproc);
}
//----------------------------------------------------------------------------


int _fastcall TSybaseDatabase::Connect()
{
int tmpPrompt=0;
LOGINREC     *loginrec;
TModalResult ModalResult;

  if( FConnected == true)
    return 0;

  if (DataBase.Length() == 0)
    DataBase="master";

  if(FUserName.Length()==0)tmpPrompt++;
  if(FPassword.Length()==0)tmpPrompt++;
  if(ServerName.Length()==0)tmpPrompt++;
    

  if ((LoginPrompt)||(tmpPrompt))
  try {
    LoginDlg = new TSybLoginDLG();
    LoginDlg->Caption="Login to Sybase ";
    LoginDlg->User->Text=FUserName;
    LoginDlg->Pass->Text=FPassword;
    LoginDlg->DataBase->Text=DataBase;

    ModalResult = LoginDlg->ShowModal();

    if (ModalResult == mrOk){
      FUserName=LoginDlg->User->Text;
      FPassword=LoginDlg->Pass->Text;
      ServerName=LoginDlg->ServerList->Items->Strings[LoginDlg->ServerList->ItemIndex];
      DataBase = LoginDlg->DataBase->Text;
      }
  }
  __finally {
    if(LoginDlg)delete LoginDlg;
    }

  if (ModalResult == mrCancel)return(0);
  FConnected=false;
//............................


   memset(SybErr,0,sizeof(SybErr));
   if(dbinit()==FAIL) return -1;
   loginrec = dblogin();
        if (loginrec == NULL)
        {
         if(!FCancelMessages)
         MessageDlg("Can't open DATABASE, dblogin failed\n"+StrPas(SybErr)\
         +"\n"+FPassword, mtWarning ,\
          TMsgDlgButtons() << mbOK , 0);
         if(OnDbLoginFail)OnDbLoginFail(this,SybErr);
         return(-1);
        }
   if(FEncryptPassword)
     DBSETLUSER(loginrec, (FUserName+FPasswordPlus).c_str());
   else  DBSETLUSER(loginrec, FUserName.c_str());
   DBSETLPWD(loginrec, FPassword.c_str());
   DBSETLAPP(loginrec, FAppName.c_str());
   DBSETLCHARSET(loginrec, FClientCharSet.c_str());
   DBSETLPACKET(loginrec, FPacketSize);
   if(OnBeforeLogin)OnBeforeLogin(this,loginrec);
   
   dbproc = dbopen(loginrec, ServerName.c_str());
   if (dbproc == NULL)
        {
        if(!FCancelMessages)
        MessageDlg("Can't open DATABASE, dbopen failed\n"+StrPas(SybErr), \
        mtWarning , TMsgDlgButtons() << mbOK , 0);
        if(OnDbOpenFail)OnDbOpenFail(this,SybErr);
        return(-1);
        }
   if (dbuse(dbproc,DataBase.c_str()) == FAIL)
        {
        if(!FCancelMessages)
        MessageDlg("Can't change DATABASE, dbuse failed\n"+StrPas(SybErr), mtWarning , \
         TMsgDlgButtons() << mbOK , 0);
        if(OnDbUseFail)OnDbUseFail(this,SybErr);
//        dbclose(dbproc);
	return(-1);
        }

    dbloginfree(loginrec);

      FConnected=true;
      SetBufferSize(BufferSize);
      FCharSet=dbgetcharset(dbproc);
      FServerCharSet=dbservcharset(dbproc);
      FLanguage=dbgetnatlang(dbproc);


      if (FOnConnect)  // event called here
        FOnConnect(this);

return 0;
}
//----------------------------------------------------------------------------
void _fastcall TSybaseDatabase::DisConnect()
{
  if (FConnected == true)
  {
    FConnected=false;
    dbclose(dbproc);
    dbexit();
    if(FOnDisConnect)FOnDisConnect(this);
  }
}
//----------------------------------------------------------------------------

void _fastcall TSybaseDatabase::CanQuery()
{
  if(dbcanquery(dbproc)==FAIL){
    if(!FCancelMessages)
      MessageDlg("dbcanquery failed\r"+StrPas(SybErr),\
      mtWarning , TMsgDlgButtons() << mbOK , 0);
    if(OnDbCanQueryFail)OnDbCanQueryFail(this,SybErr);
  }
}
//----------------------------------------------------------------------------

void _fastcall TSybaseDatabase::SetLoginTimeOut(int Value)
{

  if(dbsetlogintime(Value)==FAIL){
    if(!FCancelMessages)
    MessageDlg("dbsetLoginTime failed\n"+StrPas(SybErr),\
      mtWarning , TMsgDlgButtons() << mbOK , 0);
    if(OnDbSetLoginTimeFail)OnDbSetLoginTimeFail(this,SybErr);
  }

  FLoginTimeOut=Value;
}
//----------------------------------------------------------------------------
void _fastcall TSybaseDatabase::SetTimeOut(int Value)
{

  if(dbsettime(Value)==FAIL){
    if(!FCancelMessages)
    MessageDlg("dbsettime failed\n"+StrPas(SybErr),\
      mtWarning , TMsgDlgButtons() << mbOK , 0);
    if(OnDbSettimeFail)OnDbSettimeFail(this,SybErr);
  }

  FTimeOut=Value;
}
//----------------------------------------------------------------------------










