//---------------------------------------------------------------------------
#ifndef SybaseDataBaseH
#define SybaseDataBaseH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
#include <Windows.hpp>
#include <DSGNINTF.HPP>

//---------------------------------------------------------------------------
#include <StdCtrls.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
#include "SybaseCommon.h"
//---------------------------------------------------------------------------

class TServerList : public TStringList
{
 private:
 public:
   _fastcall TServerList (); //constructor
   _fastcall ~TServerList(); // destructor
  TStringList *OutStringList;
   void __fastcall CheckForSybase();

};
//---------------------------------------------------------------------------

class TSybLoginDLG : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TEdit *User;
        TEdit *Pass;
        TLabel *Label1;
        TLabel *Label2;
        TPanel *Panel2;
        TComboBox *ServerList;
        TLabel *Server;
        TSpeedButton *LoginButt;
        TSpeedButton *CancelButt;
        TLabel *Base;
        TEdit *DataBase;
        void __fastcall CancelButtClick(TObject *Sender);
        void __fastcall LoginButtClick(TObject *Sender);
        void __fastcall UserKeyPress(TObject *Sender, char &Key);
        void __fastcall PassKeyPress(TObject *Sender, char &Key);
        void __fastcall ServerListKeyPress(TObject *Sender, char &Key);
        void __fastcall DataBaseKeyPress(TObject *Sender, char &Key);
private:	// User declarations
        TServerList *ServerListSource ;
public:		// User declarations
        __fastcall virtual TSybLoginDLG();    // constructor
        __fastcall TSybLoginDLG::~TSybLoginDLG();     // destructor
        int Choice;
};
//---------------------------------------------------------------------------
// The main component
//---------------------------------------------------------------------------

typedef void __fastcall (__closure *TDBLoginrecEvent)(System::TObject* Sender, \
        LOGINREC *loginrec);
typedef void __fastcall (__closure *TDBErrEvent)(System::TObject* Sender, \
         AnsiString SybErr);


class PACKAGE TSybaseDatabase : public TComponent
{
private:

    AnsiString          FUserName;
    AnsiString          FPassword;
    TString             *FServerName;
    TString             *FUseDataBase;
    bool                FLoginPrompt;
    bool                FCancelMessages;
    bool                FConnected;
    bool                FEncryptPassword;
    int                 FBuffersize;
    int                 FPacketSize;
    AnsiString          FCharSet;   
    AnsiString          FClientCharSet;
    AnsiString          FServerCharSet;
    AnsiString          FLanguage;
    AnsiString          FAppName;
    AnsiString          FPasswordPlus;
    int                 FTimeOut;
    int                 FLoginTimeOut;    
    TSybLoginDLG        *LoginDlg;        
    void _fastcall SetPacketSize(int Value);
    int  _fastcall GetPacketSize();
    void _fastcall SetTimeOut(int Value);
    void _fastcall SetLoginTimeOut(int Value);
    void _fastcall SetUserName( AnsiString Value);
    void _fastcall SetClientCharSet( AnsiString Value);
    void _fastcall SetPassword(AnsiString Value);
    void _fastcall SetServerName(bool Value);
    void _fastcall SetLoginPrompt(bool Value);
    void _fastcall SetConnected(bool Value);
    void _fastcall SetCancelMessages(bool Value);
    void _fastcall SetShowMessage(bool Value);
    void _fastcall SetBufferSize(int Value);
    void _fastcall SetLanguage(AnsiString Value);
    void _fastcall SetAppName(AnsiString Value);
    void _fastcall SetDebugFile(AnsiString Value);
    void _fastcall SetPasswordPlus(AnsiString Value);  
    int _fastcall Connect();
    void _fastcall DisConnect(); 
    //Events
    TNotifyEvent FOnConnect;       
    TNotifyEvent FOnDisConnect;
    TDBErrEvent FOnDbSettimeFail;
    TDBErrEvent FOnDbSetLoginTimeFail;
    TDBErrEvent FOnDbCanQueryFail;
    TDBErrEvent FOnDbUseFail;
    TDBErrEvent FOnDbOpenFail;
    TDBErrEvent FOnDbLoginFail;
    TDBErrEvent FOnSetBufferSizeFail;
    TDBLoginrecEvent FOnBeforeLogin;

protected:

public:
        __fastcall  TSybaseDatabase(TComponent *Owner);
        __fastcall ~TSybaseDatabase(); 
// functions
    void _fastcall CanQuery();
// Variables
    AnsiString ServerName,DataBase; 
    DBPROCESS *dbproc;
// read only properties
    __property AnsiString ServerCharSet = { read =  FServerCharSet};
    __property AnsiString CharSet = { read =  FCharSet};
    __property AnsiString Language = { read =  FLanguage};


__published:
// read / write properties
    __property int SQLTimeOut ={ read =  FTimeOut, write =  SetTimeOut};
    __property int LoginTimeOut ={ read =  FLoginTimeOut, write =  SetLoginTimeOut};
    __property int PacketSize = { read = GetPacketSize, write = FPacketSize };
    __property AnsiString AppName = { read =  FAppName, write =  SetAppName};       
    __property AnsiString ClientCharSet = { read =  FClientCharSet, write =  SetClientCharSet};
    __property AnsiString UserPlus = { read =  FPasswordPlus, write =  SetPasswordPlus};
    __property AnsiString Password = { read =  FPassword, write =  SetPassword};
    __property AnsiString UserName = { read =  FUserName, write =  SetUserName};
    __property TString *UseServerName = {read=FServerName, write=FServerName};  
    __property TString *UseDataBase = {read=FUseDataBase, write=FUseDataBase};
    __property bool LoginPrompt  = { read =  FLoginPrompt, write =  SetLoginPrompt, default =  true};
    __property bool Connected  = { read =  FConnected, write =  SetConnected, default = false};
    __property bool CancelMessages  = { read =  FCancelMessages, write =  SetCancelMessages, default = false};
    __property int BufferSize  = { read =  FBuffersize, write =  SetBufferSize};
// events
    __property TNotifyEvent OnConnect = {read=FOnConnect, write=FOnConnect};
    __property TNotifyEvent OnDisConnect = {read=FOnDisConnect, write=FOnDisConnect}; 
    __property TDBErrEvent OnDbSettimeFail = {read=FOnDbSettimeFail, write=FOnDbSettimeFail};
    __property TDBErrEvent OnDbSetLoginTimeFail = {read=FOnDbSetLoginTimeFail, write=FOnDbSetLoginTimeFail};
    __property TDBErrEvent OnDbCanQueryFail = {read=FOnDbCanQueryFail, write=FOnDbCanQueryFail};
    __property TDBErrEvent OnDbUseFail = {read=FOnDbUseFail, write=FOnDbUseFail};
    __property TDBErrEvent OnDbOpenFail = {read=FOnDbOpenFail, write=FOnDbOpenFail};
    __property TDBErrEvent OnDbLoginFail = {read=FOnDbLoginFail, write=FOnDbLoginFail};
    __property TDBErrEvent OnSetBufferSizeFail = {read=FOnSetBufferSizeFail, write=FOnSetBufferSizeFail};
    __property TDBLoginrecEvent OnBeforeLogin = {read=FOnBeforeLogin, write=FOnBeforeLogin};
                                 
};

//---------------------------------------------------------------------------

class  TSybObjectProperty : public TPropertyEditor
{
  public:
    __fastcall ~TSybObjectProperty();  // destructor
    virtual System::AnsiString __fastcall GetValue(); // override;
    virtual void __fastcall GetValues(Classes::TGetStrProc Proc); // override;
    virtual void __fastcall SetValue(const System::AnsiString Value); // override;
    TPropertyAttributes virtual __fastcall GetAttributes(void);   // override
    virtual void __fastcall Initialize(void);     // override
    Classes::TPersistent* ThisComponent;
    TSybaseDatabase *ptr;
};

//---------------------------------------------------------------------------
#endif
